#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK20x20x20TN0x0x0_aX_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=20, NB=20, KB=20, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=2, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + (((lda) << 4)+((lda) << 2));
   const double *stN = B + (((ldb) << 4)+((ldb) << 2));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 1
   const int incAm = ((lda) - 20), incAn = -(((lda) << 4)+((lda) << 2));
   #define incBk 1
   const int incBm = -20, incBn = (((ldb) << 1));
   #define incCm 1
   const int incCn = (((ldc) << 1)) - 20;
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1;
   register double rC0_0, rC0_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         for (k=20; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rB1 = *pB1;
            rC0_1 += rA0 * rB1;
            pA0 += incAk;
            pB0 += incBk;
            pB1 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
